#ifndef PLAYERS_H

#define PLAYERS_H

#include <pthread.h>

plid_t max_players;
plid_t max_simult_players;
short int max_len_player_name;
int punish_interval;
int admin_interval;
int hashsize;
cash_t initial_cash;
int timeout;

typedef struct stock_player_s stock_player_t;
typedef struct player_s player_t;
typedef struct req_list_s req_list_t;
typedef struct result_list_s result_list_t;

struct stock_player_s {
   cid_t cid;
   qty_t qty;
   struct stock_player_s *next;
};

struct result_list_s {
   req_t req;
   cid_t cid;
   qty_t qty;
   pr_t pr;
   struct result_list_s *next;
};

struct player_s {
   pthread_t *sync_th;
   pthread_t *async_th;
   
   int client;          /* also used to set connect/disconnect status */
   int client2;
      
   char *name;
   passwd_t passwd;
   
   cash_t cash;               /* liquid resources of the player */   
   int timeout;       /* if player inactive too long, kick her out */   
   stock_player_t **holding; /* hash table of player holdings */
   
   result_list_t *head;
   result_list_t *tail;
   pthread_mutex_t result_mut;   
   pthread_cond_t result_cond;
   
#ifdef LIFE
   pthread_mutex_t player_mut;
#endif   
};

struct req_list_s {
   plid_t plid;
   cid_t cid;
   pr_t pr;
   qty_t qty;
   void (*call_fn)(int client, plid_t plid, cid_t cid, pr_t pr, qty_t qty);
   struct req_list_s *next;
};

player_t *player;

#endif /* PLAYERS_H */
